VERSION 5.00
Begin VB.Form frm_starfield 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Starfield"
   ClientHeight    =   11820
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   12210
   Icon            =   "frm_starfield.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   11820
   ScaleWidth      =   12210
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox pic_starfield 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      ForeColor       =   &H00FFFFFF&
      Height          =   11655
      Left            =   60
      ScaleHeight     =   11595
      ScaleWidth      =   11955
      TabIndex        =   0
      Top             =   60
      Width           =   12015
      Begin VB.Timer tim_refresh 
         Interval        =   1
         Left            =   720
         Top             =   1740
      End
   End
End
Attribute VB_Name = "frm_starfield"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*********************
'CUBE ENVIRONMENT
    Const cubesize = 20
    Const faces = 6
    Const points = 8
    Dim pointsX(points), pointsY(points), pointsZ(points)
    Dim transX(points), transY(points)
    Dim POLY(faces, 4)
    Dim XAngle, Yangle, Zangle, cosrotX, sinrotX, cosrotY, sinrotY, cosrotZ, sinrotZ As Double
'*********************
'STARFIELD ENVIRONMENT
    Const max_stars = 50
        Const elements = 3
            Const x = 1
            Const y = 2
            Const z = 3
    Dim stars(max_stars, elements)
'*********************
'ENVIRONMENTAL
    Const starfield_width = 320
    Const starfield_height = 240
    Const starfield_depth = 2000
    Const horizon = 1000
    Const speed = 20
    Const radius = 4
'*********************

Private Sub Form_Load()
    init_points
    connect_vertex
    rotate_cube
    draw_faces
    pic_starfield.ScaleWidth = starfield_width
    pic_starfield.ScaleHeight = starfield_height
    pic_starfield.BackColor = vbBlack
    pic_starfield.FillStyle = vbFSSolid
    randomize_starfield
    paint_starfield
End Sub

Private Sub randomize_starfield()
    For rnd_star = 1 To max_stars
        stars(rnd_star, x) = Int((starfield_width - -starfield_width + 1) * Rnd + -starfield_width)
        stars(rnd_star, y) = Int((starfield_height - -starfield_height + 1) * Rnd + -starfield_height)
        stars(rnd_star, z) = Int((starfield_depth * Rnd) + 1)
    Next rnd_star
End Sub

Private Sub paint_starfield()
    For paint_star = 1 To max_stars
        If stars(paint_star, z) > 0 Then
            newx = ((stars(paint_star, x) * horizon) / stars(paint_star, z) + (starfield_width / 2))
            newy = ((stars(paint_star, y) * horizon) / stars(paint_star, z) + (starfield_height / 2))
            newc = ((-stars(paint_star, z) + starfield_depth) / starfield_depth) * 255
            newx = newx + Sin(XAngle) * 100
            newy = newy + Sin(Yangle) * 100
            pic_starfield.FillColor = RGB(0, newc, newc)
            pic_starfield.Circle (newx, newy), ((-stars(paint_star, z) + starfield_depth) / starfield_depth) * radius, RGB(0, newc, newc)
        Else
            stars(paint_star, z) = starfield_depth
        End If
    Next paint_star
End Sub

Private Sub move_starfield()
    For move_star = 1 To max_stars
        stars(move_star, z) = stars(move_star, z) - speed
    Next move_star
End Sub

Private Sub Form_Paint()
    randomize_starfield
    paint_starfield
End Sub

Private Sub tim_refresh_Timer()
    pic_starfield.Cls
    move_starfield
    rotate_cube
    paint_starfield
    draw_faces
End Sub

Private Sub init_points()

pointsX(1) = -cubesize
pointsY(1) = -cubesize
pointsZ(1) = -cubesize

pointsX(2) = cubesize
pointsY(2) = -cubesize
pointsZ(2) = -cubesize

pointsX(3) = cubesize
pointsY(3) = cubesize
pointsZ(3) = -cubesize

pointsX(4) = -cubesize
pointsY(4) = cubesize
pointsZ(4) = -cubesize

pointsX(5) = -cubesize
pointsY(5) = -cubesize
pointsZ(5) = cubesize

pointsX(6) = cubesize
pointsY(6) = -cubesize
pointsZ(6) = cubesize

pointsX(7) = cubesize
pointsY(7) = cubesize
pointsZ(7) = cubesize

pointsX(8) = -cubesize
pointsY(8) = cubesize
pointsZ(8) = cubesize

End Sub

Private Sub connect_vertex()
    POLY(1, 1) = 1
    POLY(1, 2) = 2
    POLY(1, 3) = 3
    POLY(1, 4) = 4
    
    POLY(2, 1) = 8
    POLY(2, 2) = 7
    POLY(2, 3) = 6
    POLY(2, 4) = 5
    
    POLY(3, 1) = 2
    POLY(3, 2) = 6
    POLY(3, 3) = 7
    POLY(3, 4) = 3
    
    POLY(4, 1) = 4
    POLY(4, 2) = 8
    POLY(4, 3) = 5
    POLY(4, 4) = 1
    
    POLY(5, 1) = 5
    POLY(5, 2) = 6
    POLY(5, 3) = 2
    POLY(5, 4) = 1
    
    POLY(6, 1) = 4
    POLY(6, 2) = 3
    POLY(6, 3) = 7
    POLY(6, 4) = 8
    
End Sub


Private Sub rotate_cube()
    XAngle = XAngle + 0.03
    Yangle = Yangle + 0.02
    Zangle = Zangle + 0.01
    
    cosrotX = Cos(XAngle)
    sinrotX = Sin(XAngle)
    cosrotY = Cos(Yangle)
    sinrotY = Sin(Yangle)
    cosrotZ = Cos(Zangle)
    sinrotZ = Sin(Zangle)
    
    For P = 1 To points
        newx = (cosrotZ * pointsX(P)) - (sinrotZ * pointsY(P))
        newy = (cosrotZ * pointsY(P)) + (sinrotZ * pointsX(P))
        newZ = (sinrotY * newx) + (cosrotY * pointsZ(P))
        newx = (cosrotY * newx) - (sinrotY * pointsZ(P))
        tempY = newy
        newy = (cosrotX * newy) - (sinrotX * newZ)
        newZ = (cosrotX * newZ) + (sinrotX * tempY)

        newZ = newZ + 800
        transX(P) = (starfield_width / 2) + newx * 700 / newZ
        transY(P) = (starfield_height / 2) + newy * 700 / newZ
    Next P
End Sub

Private Sub draw_faces()
    For face = 1 To faces
        V1X = transX(POLY(face, 1)) - transX(POLY(face, 2))
        V1Y = transY(POLY(face, 1)) - transY(POLY(face, 2))
        V2X = transX(POLY(face, 3)) - transX(POLY(face, 2))
        V2Y = transY(POLY(face, 3)) - transY(POLY(face, 2))
    
        crossProduct = V1X * V2Y - V2X * V1Y
        'THE NEXT STATEMENT WHEN UNREMARKED WILL STOP INVISIBLE FACES FROM BEING DRAWN
        'If crossProduct < 0 Then
            pic_starfield.Line (transX(POLY(face, 1)), transY(POLY(face, 1)))-(transX(POLY(face, 2)), transY(POLY(face, 2))), vbRed
            pic_starfield.Line -(transX(POLY(face, 3)), transY(POLY(face, 3))), vbRed
            pic_starfield.Line -(transX(POLY(face, 4)), transY(POLY(face, 4))), vbRed
            pic_starfield.Line -(transX(POLY(face, 1)), transY(POLY(face, 1))), vbRed
        'End If
    Next face
End Sub
